/***************************************************************************
                         codbcclientobj.h  -  description
                             -------------------
    begin                : Sat Oct 30 1999
    copyright            : (C) 1999 by Team FXML
    email                : fxml@exite.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ODBCCLIENT_H_
#define __ODBCCLIENT_H_

#include "resource.h"       // main symbols
#include <string>
/////////////////////////////////////////////////////////////////////////////
// CODBCClient
class ATL_NO_VTABLE CODBCClient : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CODBCClient, &CLSID_ODBCClient>,
	public IDispatchImpl<IODBCClient, &IID_IODBCClient, &LIBID_ODBCCLIENTLib>
{

private:
	BSTR m_bsHostName;	//hostname
	BSTR m_bsConnectionString; //conn string
	short m_nPort;	//port
	void LogEvent(LPCTSTR pFormat, short nSeverity);
	SOCKET EstablishConnection(u_long nRemoteAddr, u_short nPort);
	std::string ReadAndWriteToSocket(SOCKET sd, BSTR bsSQL);
	short m_nSocketTimeout;
	u_long LookupAddress(const char* pcHost);
	short m_nDebugLevel;
	std::string SubStrReplace(std::string cOriginal, char* cSearch, char* cReplace);

public:
	CODBCClient()
	{
		m_bsHostName = NULL;
		m_bsConnectionString = NULL;
		m_nDebugLevel = 1;
		m_nPort = 9628;
		m_nSocketTimeout = 30;
	}
	~CODBCClient()
	{
		if (m_bsHostName) SysFreeString(m_bsHostName);
		if (m_bsConnectionString) SysFreeString(m_bsConnectionString);
	}
DECLARE_REGISTRY_RESOURCEID(IDR_ODBCCLIENT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CODBCClient)
	COM_INTERFACE_ENTRY(IODBCClient)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IODBCClient
public:
	STDMETHOD(get_DebugLevel)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_DebugLevel)(/*[in]*/ short newVal);
	STDMETHOD(get_SocketTimeout)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_SocketTimeout)(/*[in]*/ short newVal);
	STDMETHOD(ExecSQL)(/*[in]*/ BSTR bsSQL, /*[out, retval]*/ BSTR* bsResult);
	STDMETHOD(get_ConnectionString)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_ConnectionString)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Port)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Port)(/*[in]*/ short newVal);
	STDMETHOD(get_HostName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_HostName)(/*[in]*/ BSTR newVal);
};

#endif //__ODBCCLIENT_H_
