package ODBCSocketServer::IO;

# This is the Perl client Module for ODBC Socket Server.  Licensed under the GPL.
# (C) 1999 Team FXML

use 5.005;
use strict;
use IO::Socket;

#connect to the server
sub ExecSQL
{
	my($server, $connstr, $sql) = @_;
	
	#V 0.92 fix from Andrew Caird (acair@adams.com)
	my ( $sXML, $socket, $rin, $nfound, $rout, $timeout, $res, $answer); 

	#init socket object
	$socket = IO::Socket::INET->new(PeerAddr => $server,
		PeerPort => 9628,
		Proto => "tcp",
		Timeout => 20,
		Type => SOCK_STREAM) or return(FormatErrorString("Could not connect to host"));

	#if connected, format SQL to remove &, <, and >
        $sql =~ s/&/&amp\;/g;
        $sql =~ s/</&lt\;/g;
        $sql =~ s/>/&gt\;/g;

	#contruct XML string to send
	$sXML = "<?xml version=\"1.0\"?>\r\n<request>\r\n<connectionstring>" . $connstr . "</connectionstring>\r\n<sql>" . $sql . "</sql>\r\n</request>\r\n";

	#send XML
	print $socket $sXML;

	#read data back
	$rin = '';
	vec($rin, fileno($socket), 1) = 1;
	$timeout = 20; #20 second timeout
	$nfound = select($rout = $rin, undef, undef, $timeout);
	if (vec($rout, fileno($socket), 1))
	{
		$res = <$socket>;
		while ($res)
		{
			$answer = $answer . $res;
			$res =  <$socket>;
		}
	}
	else
	{
		$answer = FormatErrorString("Error: Timeout on Read. No response received.");
	}
	close ($socket);

	return($answer);
}

#Formats error message with XML wrapper consistent with other clients
sub FormatErrorString
{
	my $sReturn = "<?xml version=\"1.0\"?>\r\n";

	$sReturn = $sReturn . "<result status=\"failure\">\r\n<error>" . $_[0] . "</error>\r\n</result>";

	return($sReturn);
}
1;
