#!/usr/bin/perl -w
# This code is in the public domain as a sample for the perl module
# of ODBC Socket Server

# This sample creates an HTML form asking for a server's IP address,
# ODBC connection string, and SQL to execute.  It then executes the
# SQL on the specified machine and prints the results as HTML

# Of course, ODBC Socket Server must be running on the machine you
# specify!

use 5.005;
use strict;
use CGI qw(:standard);
use ODBCSocketServer::IO; #declare the ODBC Socket Server package

my(
	$TITLE, $result, $cur
);

$TITLE = "ODBC Socket Server Gateway";

print header, start_html($TITLE);
	
$cur = CGI->new();

print p("To query a SQL Server, enter data in the following areas and press the submit button.");

print start_form;
print "SQL Server to connect to:";
print $cur->textfield(
	-NAME => "server",
	-size=>12);

print "<br>";
print "ODBC Connection string to use:";
print $cur->textfield(
	-NAME => "connstring",
	-size =>15);

print "<br>";
print "SQL to Execute:";
print $cur->textfield(
	-NAME => "sql",
	-size => 30);

print p(submit("Query"));
print end_form;
if ($cur->param("sql"))
{
	#Query Server
	$result  = ODBCSocketServer::IO::ExecSQL($cur->param("server"), $cur->param("connstring"), $cur->param("sql"));
	#now replace &, < and > in string with HTML symbols
	$result =~ s/&/&amp\;/g;
	$result =~ s/</&lt\;/g;
	$result =~ s/>/&gt\;/g;
	print "<BR>";
	print p("SQL Server Response:");
	print "<PRE>";
	print $result;
	print "</PRE>";
}
print end_html;
