#!/usr/bin/perl -w
# This code is in the public domain as a sample for the perl module
# of ODBC Socket Server

# This sample creates an HTML form asking for a server's IP address,
# ODBC connection string, and SQL to execute.  It then executes the
# SQL on the specified machine and prints the results as HTML
# It then parses the XML results and prints them in a table

# Of course, ODBC Socket Server must be running on the machine you
# specify!

use 5.005;
use strict;
use CGI qw(:standard);
use ODBCSocketServer::IO; #declare the ODBC Socket Server package
use XML::Parser; #the XML Parser

my(
	$TITLE, $result, $cur
);

sub start_handler
{
    my ($p, $data) = @_;

	if ($data =~ /row/i)
	{
		#handler for the row element
		print "<tr>";
	}
	if ($data =~ /column/i)
	{
		#handler for the column
		print "<td>";
	}
	if  ($data =~ /error/i)
        {
                #handler for the error
                print "<tr><td>";
        }
        if  ($data =~ /result/i)
        {
                #handler for the result
                 print "Table of Results: <br><table border=1>";
        }
}  # End of start_handler

sub end_handler
{
    my ($p, $data) = @_;

        if ($data =~ /row/i)
        {
                #handler for the row element
                print "</tr>";
        }
        if ($data =~ /column/i)
        {
                #handler for the column
                print "</td>";
        }
        if  ($data =~ /error/i)
        {
                #handler for the error
                print "</td></tr>";
        }
        if  ($data =~ /result/i)
        {
                #handler for the result
                 print  "</table> <br>End Of Results<br>";
        }
}  # End of end_handler

sub char_handler
{
    my ($p, $data) = @_;
	print "$data";
} # End of char handler

$TITLE = "ODBC Socket Server XML Test";

print header, start_html($TITLE);
	
$cur = CGI->new();

print p("To query a SQL Server, enter data in the following areas and press the submit button.");

print start_form;
print "SQL Server to connect to:";
print $cur->textfield(
	-NAME => "server",
	-size=>12);

print "<br>";
print "ODBC Connection string to use:";
print $cur->textfield(
	-NAME => "connstring",
	-size =>15);

print "<br>";
print "SQL to Execute:";
print $cur->textfield(
	-NAME => "sql",
	-size => 30);

print p(submit("Query"));
print end_form;
if ($cur->param("sql"))
{
	#Query Server
	$result  = ODBCSocketServer::IO::ExecSQL($cur->param("server"), $cur->param("connstring"), $cur->param("sql"));
	
	#first, lets parse the XML returned
	my $parser = new XML::Parser(ErrorContext => 2);
	$parser->setHandlers(Start => \&start_handler,
			     End => \&end_handler,
                             Char  => \&char_handler);
	$parser->parse($result);

	#now replace &, < and > in string with HTML symbols
	$result =~ s/&/&amp\;/g;
	$result =~ s/</&lt\;/g;
	$result =~ s/>/&gt\;/g;
	print "<BR>";
	print p("SQL Server Response in raw form:");
	print "<PRE>";
	print $result;
	print "</PRE>";
}
print end_html;
